#ifndef GLOBALS_H
#define GLOBALS_H

#include <time.h>

#define IF_DEBUG( level, action )    if ( DebugLevel >= level ) { action; }

#define MAX( X, Y )     ( (X) >= (Y) ? (X) : (Y) )
#define MIN( X, Y )     ( (X) <= (Y) ? (X) : (Y) )

#define STDIN   0
#define STDOUT  1

extern int DebugLevel;
// DebugLevel >= 5: periodical information
// DebugLevel < 5:  on demand information

double TimeInMsec( struct timeval &tv );

double TimeInUsec( struct timeval &tv );

double delta_t( const timeval &t1, const timeval &t2 );

timeval Timeval( double usec );

void GetCurrentTime( struct timeval &time );

bool DebugOn( int probe_id );

#endif
