#ifndef PONG_DAEMON_H
#define PONG_DAEMON_H

#include "Globals.h"
#include "Pong_Common.h"
#include "Message.h"

#define TRAN_START      1
#define TRAN_END        2

#define ST_FREE         0
#define ST_SND_TRY      1  
#define ST_SND_RUN      2
#define ST_RCV_TRY      3
#define ST_RCV_RUN      4
#define ST_CANCEL       5
#define ST_OUTDATE      6
#define ST_TMP_FAIL     7
#define ST_PMT_FAIL     8
#define ST_TRA          9

#define HB_QUITTED      0
#define HB_CORRUPT      1
#define HB_BOOT         2
#define HB_RUN          3
#define HB_CANCEL       4
#define HB_NOCONN       5
#define HB_OUTDATE      6
#define HB_RMTOD        7
#define HB_CNCL_RA      8
#define HB_CNCL_IHN     9
#define HB_QUIT_RA      10
#define HB_TRA          11
#define HB_SIG_TERM     12
#define HB_ACDENY       13

#define E_UNKNOWN       0
#define E_RA            1
#define E_QUIT          2
#define E_NO_HB         3
#define E_SIG_TERM      4
#define E_RA_NO_HB      5
#define E_DMN_TERM      6
#define E_TIME_UP       7

// Thresholds of heartbeat
#define TH_DT_BOOT_SND 100
#define TH_DT_BOOT_RCV 80
#define TH_DT_RUN      70

#define TH_ACCESS_DENY 3
#define TH_BOOT_FAIL   5

void Usage( char *argv0 );

void ParseCommand( int argc, char **argv );

void Sig_Term( int sig_num );

void PrintPID( void );

void InitializeArchive( void );

void PrintXID( int transaction_type );

void CheckProcess( void );

pid_t PongAlive( void );
bool PongAlive( pid_t pid );

void RunDaemon( void );

int CheckPongHeartBeat( int& dt );

void SetupMonitorServer( void );

void SetupControlServer( void );

void SetupControlProcess( void );

void * control_process( void * arg );

void AcceptMonitorClient( void );

void AcceptControlClient( void );

void ProcessInteractiveCommand( void );

void ProcessBinaryCommand( void );

void HelpInteractiveCommand( void );

void FreeState( void );

void Query( void );

void Quit( void );

void TearDownClient( void );

const char * GetMeasurementTime( void );

void ReceiveCommands( void );

void GenerateShellScript( int the_role, const char * target_host );

int SaveMeasurementData( int end_reason = E_UNKNOWN );

void TerminatePong( void );

void RunPong( void );

long RecvCtrCode( void );


#endif
