#ifndef  __IP_TO_AS__
#define  __IP_TO_AS__

#define MASK_NUMBER(m) ((1<<(m))-1)<<(32 - (m))

#define SON_NUMBER_STEP 10
#define MAX_CONFIG_LINE_WIDTH   200

class PrefixNode 
{
friend class PrefixTree;
public:
    PrefixNode();
    PrefixNode(unsigned int ip, unsigned int mask, int as);
    ~PrefixNode();
    void destroy();         // destroy the whole tree, called only by the root.
protected:
    int IptoAS(unsigned int ip);
    int IptoAS(unsigned int ip, int &nmask, char *&nstring);
    void addNode(PrefixNode *pn);
    int bitmatch(unsigned ip1, unsigned ip2, int end, int start = 1);
    void extendSonStorage();
public:
    char *m_string;         // the entry string
protected:
    bool m_leaf;            // if this node is a leaf or not
    int m_asnumber;         // AS number

    int m_mask;            // mask number
    unsigned int m_prefix;          // the prefix of this node

    int m_father_mask;      // the mask of father node

    int m_son_num;          // the number of sons
    int m_son_num_max;      // the max number of sons that can be stored in m_sons
    PrefixNode **m_sons;    // son nodes    
};

class PrefixTree
{
public:
    PrefixTree();
    ~PrefixTree();
    bool readASFile(const char *fname);    
    int IptoAS(unsigned int ip);
    int IptoAS(const char *str_ip);    
protected:
    int net_addr(const char *saddr);    
    void addNode(PrefixNode *pn);
protected:
    PrefixNode *m_root;
};

#endif
